#include <iostream>
#include <iomanip>
#include <fstream>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string>

using namespace std;

//CellNX̐錾
class Cell{

public:
	float latitude;				// ܓx [b] latitude [second]
	float longitude;				// ox [b] longitude [second]
	float med;					/* Ԓl[m] */
	int rainCellNumber;			/* ~Jϑԍ */
	class ROF* ROFCell;			/* ̃Obh܂܂~ʃZ */

	void setElevation(int rowStep, int colStep, int row, int col, 
			float lat, float lon, int TopoScale, float medElevation);
	void setROFCell(ROF** fROF, int row_ROF, int col_ROF);
};

// ROFNX̐錾
class ROF{
public:

	float latitude;		// latitude of data grid center ObhS̈ܓx
	float longitude;		// longitude of data grid center ObhŠox
	int col;				// column number for input data, starting from 1.
	int row;				// row number for input data, starting from 1.

	void setInformation(float* lat, float* lon, int x, int y);
};


int main()
{

	// 萔̒`  Definition of constant value
	//const int forOneCell = 1;  /* 1̃Z\Obh */
	const float Delta_x = 0.18750; /* input data grid size (deree) */

	cout << "Reading parameters for runoff simulation." << endl;
	ifstream finParam("./param.dat");
	if(!finParam){
		cout << "param-event.dat cannot open." << endl;
		return 1;
	}

	// vZ̈ simulation range
	cout << "1) Reading parameters for study area." << endl;

	int wCol, wRow, wTopoScale;
	float wSWLON, wSWLAT;

	finParam >> wTopoScale;
	cout << "  Topography scale : " << wTopoScale << endl;

	finParam >> wCol; 
	finParam >> wRow; 
	cout << "  Number of col : " << wCol << "  Number of row : " << wRow << endl;

	finParam >> wSWLON; 
	finParam >> wSWLAT;
	cout << " Sorth West corner Longitude (degree) : " << wSWLON 
		 << " Latitude (deg) : " << wSWLAT << endl;

	const int TopoScale = wTopoScale;  // Topography scale
	const int Col = wCol;     // column number of study area
	const int Row = wRow;     // row number of study area
	const float SWLON = wSWLON; // South west corner of longitude (degree)
	const float SWLAT = wSWLAT; // South west corner of latiitude (degree)

	// ̓f[^̈ input data range
	cout << "2) Reading parameters for input data." << endl;

	int wROFnum_row, wROFnum_col;
	float wDelta_x, wDelta_y, wROF_WLON, wROF_SLAT;
	finParam >> wROFnum_col;
	finParam >> wROFnum_row;
	cout << "  Number of col : " << wROFnum_col 
		 << "  Number of row : " << wROFnum_row << endl;

	int wpO_x, wpO_y;
	finParam >> wpO_x;
	finParam >> wpO_y;
	cout << "  Origin column number : " << wpO_x 
		 << " row number : " << wpO_y << endl;

	finParam >> wROF_WLON; 
	cout << "  West corner longitude of input data : " << wROF_WLON << endl;

	const int ROFnum_col = wROFnum_col;
	const int ROFnum_row = wROFnum_row; 
	const int pO_x = wpO_x;
	const int pO_y = wpO_y;
	const float ROF_WLON = wROF_WLON;

	finParam.close();
	//--------------------- end parameter reading ------------------------------------------------

	//ϐ̒` dif-variables
	FILE *fCorrectedMed;
	float med;

	float ROFlat;
	float ROFlon;

	// Memory assignment for grid cell of simulation
	class Cell** cellObject; 
	cellObject = new class Cell*[Row];
	for(int i=0; i<Row; i++){
		cellObject[i] = new class Cell[Col];
	}

	// Memory assignment for data cell of input data
	class ROF** rofObject;
	rofObject = new class ROF*[ROFnum_row];
	for(int i=0; i<ROFnum_row; i++){
		rofObject[i] = new class ROF[ROFnum_col];
	}

	// Set latitude and longitude information
	ifstream fin("./topoData/dataLatitude.dat");
	if(!fin){
		cout << "dataLatitude.dat cannot open.\n";
		return 1;
	}

	// Set latitude and longitude information of rainfall
	for(int i=0; i<ROFnum_row; i++){
		fin >> ROFlat;  // read latitude from dataLatitude.dat ܓx
		for(int j=0; j<ROFnum_col; j++){
			ROFlon = ROF_WLON + 0.5*Delta_x + Delta_x*j; // set longitude ox 
			// Delta_x = 0.18750: oʃf[^̌oxԊu[degree]
			rofObject[i][j].setInformation(&ROFlat, &ROFlon, j+pO_x, i+pO_y);
		}
	}

	// set elevation data 
	//if(error = fopen_s(&fCorrectedMed, "./modDem.bin", "rb") != NULL) {
	if ((fCorrectedMed = fopen("./topoData/modDem.bin", "rb")) == NULL) {
		cout << "modDem.bin cannot open." << endl;
		exit(1);
	}

	for(int i=Row-1; i>=0; i--){ // DEM data arranges from south to north
		for(int j=0; j<Col; j++){
			fread(&med, sizeof(float), 1, fCorrectedMed);
			cellObject[i][j].setElevation(i, j, Row, Col, SWLAT, SWLON, TopoScale, med);
		}
	}

	fclose(fCorrectedMed);

	/* ROFCell ԗʂ p^ set parameters */
	for(int i=0; i<Row; i++){
		for(int j=0; j<Col; j++){
			cellObject[i][j].setROFCell(rofObject, ROFnum_row, ROFnum_col);
		}
	}	
	
	ofstream outFileBin;
	outFileBin.open("./topoData/inputMap.bin", ios::out | ios::binary);

	int val;
	for(int i=Row-1; i >= 0; i--) { // latitude direction from South to North for Grads format
		for(int j=0; j < Col; j++) {  // longitude direction from West
			val = cellObject[i][j].rainCellNumber;
			if(cellObject[i][j].med < 0.0) {
				val = -9999;
			}
			outFileBin.write((char*)&val, sizeof(int));
		}
	}	
	outFileBin.close();

	ofstream outFileAsc;
	outFileAsc.open("./topoData/inputMap.asc");

	outFileAsc << "ncols " << Col << "\n";
	outFileAsc << "nrows " << Row << "\n";
	outFileAsc << "xllcorner " << SWLON << "\n";
	outFileAsc << "yllcorner " << SWLAT << "\n";
	outFileAsc << "cellsize " << Delta_x << "\n";
	outFileAsc << "NODATA_value "<< -9999 ;
	outFileAsc << endl;

	for(int i=0; i < Row; i++){ // latitude direction from North to South for ArcGIS format
		for(int j=0; j<Col; j++){
			val = cellObject[i][j].rainCellNumber;
			if(cellObject[i][j].med < 0.0) {
				val = -9999;
			}
			outFileAsc << " " << val;
		}
		outFileAsc << endl;
	}	
	outFileAsc.close();

	for(int i=0; i<Row; i++){
		delete[] cellObject[i];
	}
	delete[] cellObject;

	for(int i=0; i<ROFnum_row; i++){
		delete[] rofObject[i];
	}
	delete[] rofObject;

	return 0;
}


// ܓxEoxEox30b̒EőlEԒlEŏlE[̃Obhǂ߂B
// 30b(1km)f̊iqTCYłBlatitude(ܓx)̃ObhTCY͖111.2kmœłB
// longitude(ox)̃TCY͈ܓxɂĈقȂ̂ŌvZKvB

void Cell::setElevation (
	int rowStep, // row counter
	int colStep, // column counter
	int nRow, // number of row for the study area
	int nCol, //number of column for the study area
	float SWlat, // South west corner of latitude
	float SWlon, // South west corner of longitude
	int TopoScale, // Topography scale. 1 means 3 seconds.
	float medElevation
)
{
	// setting latitude in 'sec' unit
	latitude  = (float)(SWlat*3600 + 3*TopoScale*(nRow-rowStep-1) + 1.5*TopoScale); //3: gridcell size in second.

	// setting longitude in 'sec' unit
	longitude = (float)(SWlon*3600) + 3*TopoScale*colStep + 1.5*TopoScale;

	med = medElevation;
}

/* ̃Obh܂܂ROFZ߂ */
void Cell::setROFCell(ROF** fROF, int row_ROF, int col_ROF)
{
	double x=(double)latitude/3600.0;
	double y=(double)longitude/3600.0;
	double distance;
	double distance_min;

	distance_min=100000000000000000000000000000.0;

	for(int i=0; i<row_ROF; i++){
		for(int j=0; j<col_ROF; j++){

			distance = sqrt(pow(x-(double)fROF[i][j].latitude, 2.0)
						+pow(y-(double)fROF[i][j].longitude, 2.0));
			
			if(distance < distance_min){
				
				ROFCell=&fROF[i][j];

				distance_min = distance;
				rainCellNumber = i*col_ROF + j + 1;
			}
		}
	}

}


//setInfomation֐̐錾
void ROF::setInformation(float* lat, float* lon, int x_col, int y_row)
{
	latitude = *lat;
	longitude = *lon;
	if(longitude > 180.0) longitude = longitude - 360.0;

	col = x_col; // column number of input data, starting from p0_x.
	row = y_row; // row number of input data, starting from pO_y.
}

